

public Action:ChatHookHandler (client, args)
{
    if (client == 0)
        return Plugin_Continue;

    if (GetConVarBool (g_cVarEnable))
    {
        decl String:szCommandBuffer[192] = "";
        decl String:szArgs[MAX_ARGS+1][100];
        static iIndex = 0, iArgs = 0, iPos = -1, iLen = 0;
        static AdminId:AdminID = INVALID_ADMIN_ID;

        GetCmdArgString (szCommandBuffer, sizeof (szCommandBuffer));
        TrimString (szCommandBuffer);

        iIndex = 0;
        iArgs = 0;

        if (szCommandBuffer[0] == '"')
        {
            iLen = strlen (szCommandBuffer);
            if (szCommandBuffer[iLen-1] == '"')
                szCommandBuffer[iLen-1] = '\0';
            iIndex++;
        }

        /* Grab the arguments */
        while ((iArgs <= MAX_ARGS) && (iIndex <= sizeof (szCommandBuffer)))
        {
            if ((iPos = BreakString (szCommandBuffer[iIndex], szArgs[iArgs], sizeof (szArgs[]))) == -1)
                break;
            iIndex += iPos;
            iArgs++;
        }

        /*******************************************************************************
         *
         *                Public Commands Go Here...
         *
         *******************************************************************************
        */

        if (!strcmp (szArgs[0], "!version", false))
        {
            PrintToChat (client, "%T", "YGMSM Version", LANG_SERVER, PLUGIN_VERSION, SOURCEMOD_VERSION);
            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!time", false))
        {
            decl String:szTime[64];
            FormatTime (szTime, sizeof (szTime), "%H:%M:%S - %d/%m/%Y");
            PrintToChat (client, szTime);
            return Plugin_Handled;
        }

        /* grab arg 0 "say" or "say_team" to block a client from talking to the whole server */
        /* only allow team chat if a client is muted */
        decl String:szArgBuffer[32] = "";
        GetCmdArg (0, szArgBuffer, sizeof (szArgBuffer));
        if (g_bClientMuted[client] && !strcmp (szArgBuffer, "say", false))
            return Plugin_Handled;

        if (((AdminID = GetUserAdmin (client)) == INVALID_ADMIN_ID) && !GetAdminFlag (AdminID, Admin_RCON, Access_Effective))
            return Plugin_Continue;

        /*******************************************************************************
         *
         *                 Admin Commands Go Here....
         *
         *******************************************************************************
        */

        if (!strcmp (szArgs[0], "!yg", false))
        {
            if (g_hAdminMenu != INVALID_HANDLE)
                DisplayMenu (g_hAdminMenu, client, MENU_TIME_FOREVER);
            else
                SetFailState ("[YGMSM] Error - Admin menu handle is invalid");

            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!console", false))
        {
            ServerCommand ("say %s", szArgs[1]);
            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!say", false))
        {
            PrintToChatAll ("%s", szArgs[1]);
            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!map", false))
        {
            if (iArgs > 0)
            {
                ServerCommand ("changelevel %s", szArgs[1]);
            }
            else if (g_hMapChangeMenu != INVALID_HANDLE)
            {
                DisplayMenu (g_hMapChangeMenu, client, MENU_TIME_FOREVER);
            }
            else
            {
                PrintToChat (client, "%T", "No maps available to display the menu", LANG_SERVER);
            }

            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!config", false))
        {
            if (iArgs > 0)
            {
                PrintToChat (client, "%T", "Executing config", LANG_SERVER, szArgs[1]);
                ServerCommand ("exec %s", szArgs[1]);
            }
            else if (g_hConfigLoadMenu != INVALID_HANDLE)
            {
                DisplayMenu (g_hConfigLoadMenu, client, MENU_TIME_FOREVER);
            }
            else
            {
                PrintToChat (client, "%T", "No configs available to display the menu", LANG_SERVER);
            }

            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!record", false))
        {
            if (!g_bSourceTVActive)
            {
                PrintToChat (client, "%T", "Source TV not active", LANG_SERVER);
            }
            else if (g_szDemoRecordName[0] != '\0')
            {
                CreateDemoStopRecordMenu (client);
            }
            else if (iArgs == 0)
            {
                if (GetArraySize (g_hArrayRecordNames) > 0)
                {
                    CreateDemoRecordMenu (client);
                }
                else
                {
                    PrintToChat (client, "%T", "No Demo Record Names", LANG_SERVER);
                    PrintToChat (client, "%T", "Demo Record Format", LANG_SERVER);
                }
            }
            else if (iArgs == 1)
            {
                decl String:szClientName[MAX_NAME_LENGTH] = "";
                
                CheckForDemExtension (g_szDemoRecordName, sizeof (g_szDemoRecordName));
                CheckForRecordDirectory (g_szDemoRecordName, sizeof (g_szDemoRecordName));
                ServerCommand ("tv_record %s", g_szDemoRecordName);
                GetClientName (client, szClientName, sizeof (szClientName));
                PrintToChatAll ("%T", "Client Started Recording To", LANG_SERVER, szClientName, g_szDemoRecordName);
                CreateTimer (30.0, DemoRecordCheckPlayerCount, _, TIMER_REPEAT);
            }
            else
            {
                PrintToChat (client, "Invalid Demo Record Format - use !record <demoname.dem>");
            }

            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!stoprecord", false))
        {
            if (g_szDemoRecordName[0] != '\0')
            {
                CreateDemoStopRecordMenu (client);
            }
            else
            {
                PrintToChat (client, "%T", "Currently Not Recording", LANG_SERVER);
            }

            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!kick", false))
        {
            if (iArgs == 0)
            {
                CreatePlayerListMenu (client, g_hPlayerKickMenu, g_szPlayerKickMenuTitle, Handler_PlayerKickMenu);
            }
            else if (iArgs == 2)
            {
                static iClient = -1, iKickTeam = -1, iMaxClients = 0;
                
                iKickTeam = 0;

                if (!strcmp ("#spec", szArgs[1], false))
                    iKickTeam = TEAM_SPEC;
				else if (!strcmp ("#t", szArgs[1], false))
				    iKickTeam = TEAM_T;
				else if (!strcmp ("#ct", szArgs[1], false))
				    iKickTeam = TEAM_CT;

                if (iKickTeam > 0)
                {
                    iClient = 1;
                    iMaxClients = GetMaxClients ();

                    while (iClient <= iMaxClients)
                    {
                        if (IsClientConnected (iClient) && IsClientInGame (iClient) && !IsFakeClient (iClient) && (GetClientTeam (iClient) == iKickTeam))
                        {
                            ServerCommand ("kickid %d %s", GetClientUserId (iClient), szArgs[2]);
						}
                        iClient++;
					}
				}
                else if ((iClient = UTIL_FindClient (client, szArgs[1])) != -1)
                    ServerCommand ("kickid %d %s", GetClientUserId (iClient), szArgs[2]);
            }
            else
            {
                PrintToChat (client, "Usage: !kick <#userid or \"#exact name\"> <\"kick message\">");
                PrintToChat (client, "Usage: !kick <partialname or \"full name\"> <\"kick message\">");
                PrintToChat (client, "Usage: !kick <#t/#ct/#spec> <\"kick message\">");
            }

            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!ban", false))
        {
            if (iArgs == 0)
            {
                CreatePlayerListMenu (client, g_hPlayerBanMenu, g_szPlayerBanMenuTitle, Handler_PlayerBanMenu);
            }
            else if (iArgs == 2)
            {
                static iClient = -1, iBanTeam = -1, iMaxClients = 0;
                
                if (IsCharNumeric (szArgs[2][0]))
                {
                    iBanTeam = 0;

                    if (!strcmp ("#spec", szArgs[1], false))
                        iBanTeam = TEAM_SPEC;
				    else if (!strcmp ("#t", szArgs[1], false))
				        iBanTeam = TEAM_T;
				    else if (!strcmp ("#ct", szArgs[1], false))
				        iBanTeam = TEAM_CT;

                    if (iBanTeam > 0)
                    {
                        iClient = 1;
                        iMaxClients = GetMaxClients ();

                        while (iClient <= iMaxClients)
                        {
                            if (IsClientConnected (iClient) && IsClientInGame (iClient) && !IsFakeClient (iClient) && (GetClientTeam (iClient) == iBanTeam))
                            {
                                ServerCommand ("banid %s %d kick", szArgs[2], GetClientUserId (iClient));
						    }
                            iClient++;
					    }
				    }
                    else if ((iClient = UTIL_FindClient (client, szArgs[1])) != -1)
                    {
                        ServerCommand ("banid %s %d kick", szArgs[2], GetClientUserId (iClient));
                    }

                    ServerCommand ("writeid");
                }
                else
                {
                    PrintToChat(client, "Invalid Ban Time %s", szArgs[2]);
                }
            }
            else
            {
                PrintToChat (client, "Usage: !ban <#userid or \"#exact name\"> <time>");
                PrintToChat (client, "Usage: !ban <partialname or \"full name\"> <time>");
                PrintToChat (client, "Usage: !ban <#t/#ct/#spec> <time>");
            }

            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!unban", false))
        {
            if (iArgs == 0)
            {
                DisplayMenu (g_hUnbanTypeMenu, client, MENU_TIME_FOREVER);
            }
            else if (iArgs == 1)
            {
                ServerCommand ("removeid %s", szArgs[1]);
                ServerCommand ("writeid");
                PrintToChat (client, "Removed server ban %s", szArgs[1]);
            }
            else
            {
                PrintToChat (client, "Invalid Format - Usage: !unban <steamid>");
			}

            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!restart", false))
        {
            UTIL_PrintToConsoleAll ("%T", "Server Restarting", LANG_SERVER);
            ServerCommand ("quit");
            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!ko3", false))
        {
            UTIL_RunKO3 (client);
            return Plugin_Handled;
        }
        else if (GetConVarBool (g_cVarEnableLO3) && !strcmp (szArgs[0], "!lo3", false))
        {
            UTIL_RunLO3 (client);
            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!rr", false))
        {
            UTIL_RunOneRR ();
            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!rcon", false))
        {
            if (iArgs > 0)
            {
                ServerCommand (szArgs[1]);
                PrintToChat (client, "%T", "Ran RCON Command", LANG_SERVER, szArgs[1]);
            }
            else
            {
                if (g_hRconCommandsMenu != INVALID_HANDLE)
                    DisplayMenu (g_hRconCommandsMenu, client, MENU_TIME_FOREVER);
                else
                    PrintToChat (client, "%T", "Invalid RCON Menu Handle", LANG_SERVER);
            }

            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!password", false))
        {
            if (iArgs == 1)
            {
                ServerCommand ("sv_password %s", szArgs[1]);
                PrintToChat (client, "%T", "Server Password Changed", LANG_SERVER, szArgs[1]);
            }
            else if (g_hServerPasswordMenu != INVALID_HANDLE)
            {
                DisplayMenu (g_hServerPasswordMenu, client, MENU_TIME_FOREVER);
            }
            else
            {
                PrintToChat (client, "%T", "No Passwords available to display the menu", LANG_SERVER);
                PrintToChat (client, "%T", "Password Change Format", LANG_SERVER);
            }

            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!mute", false))
        {
            if (iArgs == 0)
            {
                CreatePlayerListMenu (client, g_hPlayerMuteMenu, g_szPlayerMuteMenuTitle, Handler_PlayerMuteMenu);
            }
            else if (iArgs == 1)
            {
                static iClient = -1;

                if ((iClient = UTIL_FindClient (client, szArgs[1])) != -1)
                {
                    decl String:szClientName[MAX_NAME_LENGTH] = "";
                    GetClientName (iClient, szClientName, sizeof (szClientName));

                    if (g_bClientMuted[iClient])
                    {
                        g_bClientMuted[iClient] = false;
                        PrintToChat (client, "%T", "Client UnMuted", LANG_SERVER, szClientName);
                    }
                    else
                    {
                        g_bClientMuted[iClient] = true;
                        PrintToChat (client, "%T", "Client Muted", LANG_SERVER, szClientName);
                    }
                }
            }
            else
            {
                PrintToChat (client, "Usage: !mute <#userid or \"#exact name\">");
                PrintToChat (client, "Usage: !mute <partialname or \"full name\">");
            }

            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!swapteam", false))
        {
            CreatePlayerListMenu (client, g_hPlayerSwapTeamMenu, g_szPlayerSwapTeamMenuTitle, Handler_PlayerSwapTeamMenu);
            return Plugin_Handled;
        }
        else if (!strcmp (szArgs[0], "!swap", false))
        {
            if (iArgs == 2)
            {
                static iClient = -1;

                if ((UTIL_FindClient (client, szArgs[1])) != -1)
                {
                    if (!strcmp (szArgs[2], "#t", false))
                        ChangeClientTeam (iClient, TEAM_T);
                    else if (!strcmp (szArgs[2], "#ct", false))
                        ChangeClientTeam (iClient, TEAM_CT);
                    else if (!strcmp (szArgs[2], "#spec", false))
                        ChangeClientTeam (iClient, TEAM_SPEC);
                    else
                        PrintToChat (client, "Invalid team - Use #t/#ct/#spec");
                }
            }
            else
            {
                PrintToChat (client, "Usage: !swap <#userid or \"#exact name\"> <#t/#ct/#spec>");
                PrintToChat (client, "Usage: !swap <partialname or \"full name\"> <#t/#ct/#spec>");
            }

            return Plugin_Handled;
        }
    }

    return Plugin_Continue;
}

public Action:Command_Quit (args)
{
    static iClients = 0, iMinPlayersBlockQuit = 0;

    iMinPlayersBlockQuit = GetConVarInt (g_cVarMinPlayersBlockQuit);

    if (iMinPlayersBlockQuit == 0)
        return Plugin_Continue;

    iClients = GetClientCount (false) + 1;

    if (g_bSourceTVActive)
        iClients--;

    if (iClients >= iMinPlayersBlockQuit)
        return Plugin_Handled;

    return Plugin_Continue;
}
