

public Handler_PlayerKickMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_End)
    {
        UTIL_FreeHandle (menu);
    }
    else if (action == MenuAction_Select)
    {
        decl String:szInfo[10] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if ((szInfo[0] == 'b') && (szInfo[1] == 'a') && (szInfo[2] == 'c') && (szInfo[3] == 'k'))
            DisplayMenu (g_hPlayerManagementMenu, client, MENU_TIME_FOREVER);
        else
            ServerCommand ("kickid %d", GetClientUserId (StringToInt (szInfo)));
    }
}

public Handler_PlayerBanMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_End)
    {
        UTIL_FreeHandle (menu);
    }
    else if (action == MenuAction_Select)
    {
        decl String:szInfo[10] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if ((szInfo[0] == 'b') && (szInfo[1] == 'a') && (szInfo[2] == 'c') && (szInfo[3] == 'k'))
        {
            DisplayMenu (g_hPlayerManagementMenu, client, MENU_TIME_FOREVER);
        }
        else
        {
            ServerCommand ("banid 0 %d kick", GetClientUserId (StringToInt (szInfo)));
            ServerCommand ("writeid"); // write the ban to the banned_user.cfg
        }
    }
}

public Handler_PlayerMuteMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_End)
    {
        UTIL_FreeHandle (menu);
    }
    else if (action == MenuAction_Select)
    {
        decl String:szInfo[10] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if ((szInfo[0] == 'b') && (szInfo[1] == 'a') && (szInfo[2] == 'c') && (szInfo[3] == 'k'))
        {
            DisplayMenu (g_hPlayerManagementMenu, client, MENU_TIME_FOREVER);
        }
        else
        {
            static iMutedClient = 0;
            decl String:szClientName[MAX_NAME_LENGTH] = "";

            iMutedClient = StringToInt (szInfo);
            GetClientName (iMutedClient, szClientName, sizeof (szClientName));

            if (g_bClientMuted[iMutedClient])
            {
                g_bClientMuted[iMutedClient] = false;
                PrintToChat (client, "%T", "Client UnMuted", LANG_SERVER, szClientName);
            }
            else
            {
                g_bClientMuted[iMutedClient] = true;
                PrintToChat (client, "%T", "Client Muted", LANG_SERVER, szClientName);
            }
        }
    }
}

public Handler_PlayerSwapTeamMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_End)
    {
        UTIL_FreeHandle (menu);
    }
    else if (action == MenuAction_Select)
    {
        decl String:szInfo[3] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if ((szInfo[0] == 'b') && (szInfo[1] == 'a') && (szInfo[2] == 'c') && (szInfo[3] == 'k'))
        {
            DisplayMenu (g_hPlayerManagementMenu, client, MENU_TIME_FOREVER);
        }
        else
        {
            CreateTeamSwapMenu (client, szInfo);
        }
    }
}

public Handler_SwapTeamChoiceMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_End)
    {
        UTIL_FreeHandle (menu);
    }
    else if (action == MenuAction_Select)
    {
        decl String:szInfo[10] = "", String:szClient[4] = "", String:szTeam[4] = "";
        static iTeam = 0, iClient = 0, iSize = 0;

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if ((szInfo[0] == 'b') && (szInfo[1] == 'a') && (szInfo[2] == 'c') && (szInfo[3] == 'k'))
        {
            CreatePlayerListMenu (client, g_hPlayerSwapTeamMenu, g_szPlayerSwapTeamMenuTitle, Handler_PlayerSwapTeamMenu);
        }
        else
        {
            iSize = 0;
            while ((szInfo[iSize] != '|') && (iSize < 10))
                iSize++;
            szClient[0] = szInfo[0];
            szClient[1] = '\0';
            if (iSize > 1)
            {
			    szClient[1] = szInfo[1];
			    szClient[2] = '\0';
            }
            iClient = StringToInt (szClient);
            szTeam[0] = szInfo[iSize+1];
            szTeam[1] = '\0';
            iTeam = StringToInt (szTeam);
            ChangeClientTeam (iClient, iTeam);
		}
    }
}
public Handler_MapChangeMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_Select)
    {
        decl String:szInfo[32] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if ((szInfo[0] == 'm') && (szInfo[1] == 'e') && (szInfo[2] == 'n') && (szInfo[3] == 'u') && (szInfo[4] == 'b') && (szInfo[5] == 'k'))
        {
            DisplayMenu (g_hServerManagementMenu, client, MENU_TIME_FOREVER);
        }
        else
        {
            PrintToChatAll ("%T", "Changing Map To", LANG_SERVER, szInfo);
            ServerCommand ("changelevel %s", szInfo);
        }
    }
}

public Handler_LoadConfigMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_Select)
    {
        decl String:szInfo[32] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if ((szInfo[0] == 'm') && (szInfo[1] == 'e') && (szInfo[2] == 'n') && (szInfo[3] == 'u') && (szInfo[4] == 'b') && (szInfo[5] == 'k'))
        {
            DisplayMenu (g_hServerManagementMenu, client, MENU_TIME_FOREVER);
        }
        else
        {
            PrintToChat (client, "%T", "Executing config", LANG_SERVER, szInfo);
            ServerCommand ("exec %s", szInfo);
        }
    }
}

public Handler_RecordMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_End)
    {
        UTIL_FreeHandle (menu);
    }
    else if (action == MenuAction_Select)
    {
        if (!g_bSourceTVActive)
        {
		    PrintToChat (client, "%T", "Source TV not active", LANG_SERVER);
		}
        else if (g_szDemoRecordName[0] == '\0')
        {
            decl String:szInfo[PLATFORM_MAX_PATH] = "";

            GetMenuItem (menu, param, szInfo, sizeof (szInfo));

            if ((szInfo[0] == 'b') && (szInfo[1] == 'a') && (szInfo[2] == 'c') && (szInfo[3] == 'k'))
            {
                DisplayMenu (g_hServerManagementMenu, client, MENU_TIME_FOREVER);
            }
            else
            {
                decl String:szClientName[MAX_NAME_LENGTH] = "";

                strcopy (g_szDemoRecordName, sizeof (g_szDemoRecordName), szInfo);
                CheckForDemExtension (g_szDemoRecordName, sizeof (g_szDemoRecordName));
                CheckForRecordDirectory (g_szDemoRecordName, sizeof (g_szDemoRecordName));
                ServerCommand ("tv_record %s", g_szDemoRecordName);
                GetClientName (client, szClientName, sizeof (szClientName));
                PrintToChatAll ("%T", "Client Started Recording To", LANG_SERVER, szClientName, g_szDemoRecordName);
                CreateTimer (30.0, DemoRecordCheckPlayerCount, _, TIMER_REPEAT);
            }
        }
        else
        {
            PrintToChat (client, "%T", "Already Recording Source TV", LANG_SERVER, g_szDemoRecordName);
        }
    }
}

public Handler_StopRecordMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_End)
    {
        UTIL_FreeHandle (menu);
    }
    else if (action == MenuAction_Select)
    {
        decl String:szInfo[32] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if ((szInfo[0] == '2') && (szInfo[1] == '\0'))
        {
            DisplayMenu (g_hServerManagementMenu, client, MENU_TIME_FOREVER);
		}
		else
		{
            ServerCommand ("tv_stoprecord");
            PrintToChat (client, "%T", "Completed Recording Demo", LANG_SERVER, g_szDemoRecordName);
            g_szDemoRecordName[0] = '\0';
        }
    }
}

public Handler_PasswordMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_Select)
    {
        decl String:szInfo[32] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if ((szInfo[0] == 'm') && (szInfo[1] == 'e') && (szInfo[2] == 'n') && (szInfo[3] == 'u') && (szInfo[4] == 'b') && (szInfo[5] == 'k'))
        {
            DisplayMenu (g_hServerManagementMenu, client, MENU_TIME_FOREVER);
        }
        else
        {
            ServerCommand ("sv_password %s", szInfo);
            PrintToChat (client, "%T", "Server Password Changed", LANG_SERVER, szInfo);
        }
    }
}

public Handler_RconCommandListMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_Select)
    {
        decl String:szInfo[32] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if ((szInfo[0] == 'm') && (szInfo[1] == 'e') && (szInfo[2] == 'n') && (szInfo[3] == 'u') && (szInfo[4] == 'b') && (szInfo[5] == 'k'))
            DisplayMenu (g_hServerManagementMenu, client, MENU_TIME_FOREVER);
        else
        {
            ServerCommand (szInfo);
            PrintToChat (client, "%T", "Ran RCON Command", LANG_SERVER, szInfo);
        }
    }
}

public Handler_Lo3Ko3RRMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_Select)
    {
        decl String:szInfo[4] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if (szInfo[0] == '1')
        {
            UTIL_RunKO3 (client);
        }
        else if (szInfo[0] == '2')
        {
            UTIL_RunLO3 (client);
        }
        else if (szInfo[0] == '3')
        {
            UTIL_RunOneRR ();
        }
        else if (szInfo[0] == '4')
        {
            DisplayMenu (g_hServerManagementMenu, client, MENU_TIME_FOREVER);
		}
    }
}

public Handler_AdminMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_Select)
    {
        decl String:szInfo[4] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if (szInfo[0] == '1')
            DisplayMenu (g_hPlayerManagementMenu, client, MENU_TIME_FOREVER);
        else if (szInfo[0] == '2')
            DisplayMenu (g_hServerManagementMenu, client, MENU_TIME_FOREVER);
    }
}

public Handler_PlayerManagementMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_Select)
    {
        decl String:szInfo[4] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        switch (szInfo[0])
        {
            case '1':
                CreatePlayerListMenu (client, g_hPlayerKickMenu, g_szPlayerKickMenuTitle, Handler_PlayerKickMenu);
            case '2':
                CreatePlayerListMenu (client, g_hPlayerBanMenu, g_szPlayerBanMenuTitle, Handler_PlayerBanMenu);
            case '3':
                DisplayMenu (g_hUnbanTypeMenu, client, MENU_TIME_FOREVER);
            case '4':
                CreatePlayerListMenu (client, g_hPlayerMuteMenu, g_szPlayerMuteMenuTitle, Handler_PlayerMuteMenu);
            case '5':
                CreatePlayerListMenu (client, g_hPlayerSwapTeamMenu, g_szPlayerSwapTeamMenuTitle, Handler_PlayerSwapTeamMenu);
            case '6':
                DisplayMenu (g_hAdminMenu, client, MENU_TIME_FOREVER);
            default:
                return;
        }
    }
}

public Handler_ServerManagementMenu (Handle:menu, MenuAction:action, client, param2)
{
    if (action == MenuAction_Select)
    {
        decl String:szInfo[4] = "";

        GetMenuItem (menu, param2, szInfo, sizeof (szInfo));

        switch (szInfo[0])
        {
            case '1':
                DisplayMenu (g_hMapChangeMenu, client, MENU_TIME_FOREVER);
            case '2':
                DisplayMenu (g_hLo3Ko3RRMenu, client, MENU_TIME_FOREVER);
            case '3':
                CreateDemoRecordMenu (client);
            case '4':
                CreateDemoStopRecordMenu (client);
            case '5':
                DisplayMenu (g_hServerPasswordMenu, client, MENU_TIME_FOREVER);
            case '6':
                DisplayMenu (g_hConfigLoadMenu, client, MENU_TIME_FOREVER);
            case '7':
                DisplayMenu (g_hAdminMenu, client, MENU_TIME_FOREVER);
            case '8':
                DisplayMenu (g_hRconCommandsMenu, client, MENU_TIME_FOREVER);
            default:
                return;
        }
    }
}

public Handler_UnbanTypeMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_Select)
    {
        decl String:szInfo[4] = "";

        GetMenuItem (menu, param, szInfo, sizeof (szInfo));

        if (szInfo[0] == '1')
        {
            if (GetArraySize (g_hArrayIDBans) > 0)
            {
			    CreateUnbanMenu (client, BAN_TYPE_ID);
            }
            else
            {
                PrintToChat (client, "No Steam ID bans found to display the menu");
                DisplayMenu (g_hUnbanTypeMenu, client, MENU_TIME_FOREVER);
            }
        }
        else if (szInfo[0] == '2')
        {
            if (GetArraySize (g_hArrayIPBans) > 0)
            {
			    CreateUnbanMenu (client, BAN_TYPE_IP);
            }
            else
            {
                PrintToChat (client, "No IP bans found to display the menu");
                DisplayMenu (g_hUnbanTypeMenu, client, MENU_TIME_FOREVER);
            }
            
        }
        else if (szInfo[0] == '3')
        {
            DisplayMenu (g_hPlayerManagementMenu, client, MENU_TIME_FOREVER);
        }
    }
}

public Handler_UnbanIDMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_End)
    {
        UTIL_FreeHandle (menu);
	}
    else if (action == MenuAction_Select)
    {
        decl String:szBanIndex[12] = "", String:szBan[32] = "";
        static iIndex = 0;

        GetMenuItem (menu, param, szBanIndex, sizeof (szBanIndex));

        if ((szBanIndex[0] == 'b') && (szBanIndex[1] == 'a') && (szBanIndex[2] == 'c') && (szBanIndex[3] == 'k'))
        {
            DisplayMenu (g_hUnbanTypeMenu, client, MENU_TIME_FOREVER);
		}
		else
		{
            iIndex = StringToInt (szBanIndex);
            GetArrayString (g_hArrayIDBans, iIndex, szBan, sizeof (szBan));
            RemoveFromArray (g_hArrayIDBans, iIndex);
            ServerCommand ("removeid %s", szBan);
            ServerCommand ("writeid"); // Rewrite the banned_user.cfg
            PrintToChat (client, "Removed ban %s", szBan);
        }
    }
}

public Handler_UnbanIPMenu (Handle:menu, MenuAction:action, client, param)
{
    if (action == MenuAction_End)
    {
        UTIL_FreeHandle (menu);
	}
    else if (action == MenuAction_Select)
    {
        decl String:szBanIndex[12] = "", String:szBan[32] = "";
        static iIndex = 0;

        GetMenuItem (menu, param, szBanIndex, sizeof (szBanIndex));

        if ((szBanIndex[0] == 'b') && (szBanIndex[1] == 'a') && (szBanIndex[2] == 'c') && (szBanIndex[3] == 'k'))
        {
            DisplayMenu (g_hUnbanTypeMenu, client, MENU_TIME_FOREVER);
		}
		else
		{
            iIndex = StringToInt (szBanIndex);
            GetArrayString (g_hArrayIPBans, iIndex, szBan, sizeof (szBan));
            RemoveFromArray (g_hArrayIPBans, iIndex);
            ServerCommand ("removeip %s", szBan);
            ServerCommand ("writeip"); // Rewrite the banned_ip.cfg
            PrintToChat (client, "Removed ban %s", szBan);
        }
    }
}
