

FreeMenuHandles ()
{
    // Free all the menu handles
    UTIL_FreeHandle (g_hAdminMenu);
    UTIL_FreeHandle (g_hPlayerManagementMenu);
    UTIL_FreeHandle (g_hServerManagementMenu);
    UTIL_FreeHandle (g_hMapChangeMenu);
    UTIL_FreeHandle (g_hConfigLoadMenu);
    UTIL_FreeHandle (g_hLo3Ko3RRMenu);
    UTIL_FreeHandle (g_hServerPasswordMenu);
    UTIL_FreeHandle (g_hRconCommandsMenu);
    UTIL_FreeHandle (g_hUnbanTypeMenu);
}

CreatePlayerListMenu (client, Handle:hMenu, const String:szTitle[], MenuHandler:Handler)
{
    decl String:szClientIndex[8] = "", String:szClientName[MAX_NAME_LENGTH] = "";
    static iIndex, iMaxClients, iMenuSlot;

    hMenu = CreateMenu (Handler);
    SetMenuTitle (hMenu, szTitle);

    iMaxClients = GetMaxClients ();
    iIndex = 1;
    iMenuSlot = 0;
    while (iIndex <= iMaxClients)
    {
        if (IsClientConnected (iIndex) && !IsFakeClient (iIndex))
        {
            GetClientName (iIndex, szClientName, sizeof (szClientName));
            Format (szClientIndex, sizeof (szClientIndex), "%d", iIndex);
            AddMenuItem (hMenu, szClientIndex, szClientName);
            iMenuSlot++;
        }
        if (iMenuSlot == 6)
        {
            AddMenuItem (hMenu, "back", "Back");
            iMenuSlot++;
		}
        iIndex++;
    }

    while (iMenuSlot <= 6)
    {
        if (iMenuSlot == 6)
            AddMenuItem (hMenu, "back", "Back");
		else
		    AddMenuItem (hMenu, "", "", ITEMDRAW_SPACER);
        iMenuSlot++;
    }

    DisplayMenu (hMenu, client, MENU_TIME_FOREVER);
}

CreateDemoRecordMenu (client)
{
    if (!g_bSourceTVActive)
    {
        PrintToChat (client, "%T", "Source TV not active", LANG_SERVER);
        DisplayMenu (g_hServerManagementMenu, client, MENU_TIME_FOREVER);
        return;
    }

    new Handle:hRecordMenu = INVALID_HANDLE;
    static iIndex = 0, iSize = 0 , iMenuSlot = 0;
    decl String:szBuffer[PLATFORM_MAX_PATH] = "", String:szRecordName[PLATFORM_MAX_PATH] = "";

    hRecordMenu = CreateMenu (Handler_RecordMenu);
    SetMenuTitle (hRecordMenu, "Select a record format:");

    iSize = GetArraySize (g_hArrayRecordNames);
    iIndex = 0;
    iMenuSlot = 0;
    while (iIndex < iSize)
    {
        GetArrayString (g_hArrayRecordNames, iIndex, szBuffer, sizeof (szBuffer));
        SetupDemoRecordName (szBuffer, sizeof (szBuffer), szRecordName, sizeof (szRecordName));
        AddMenuItem (hRecordMenu, szRecordName, szRecordName);
        iIndex++;
        iMenuSlot++;
        if (iMenuSlot == 6)
        {
            AddMenuItem (hRecordMenu, "back", "Back");
            iMenuSlot++;
        }

    }

    while (iMenuSlot <= 6)
    {
        if (iMenuSlot == 6)
            AddMenuItem (hRecordMenu, "back", "Back");
		else
		    AddMenuItem (hRecordMenu, "", "", ITEMDRAW_SPACER);
        iMenuSlot++;
    }

    DisplayMenu (hRecordMenu, client, MENU_TIME_FOREVER);
}

CreateDemoStopRecordMenu (client)
{
    new Handle:hStopRecordMenu = INVALID_HANDLE;
    decl String:szBuffer[PLATFORM_MAX_PATH] = "";

    if (g_szDemoRecordName[0] == '\0')
    {
        PrintToChat (client, "%T", "Currently Not Recording", LANG_SERVER);
        DisplayMenu (g_hServerManagementMenu, client, MENU_TIME_FOREVER);
        return;
    }

    hStopRecordMenu = CreateMenu (Handler_StopRecordMenu);
    SetMenuTitle (hStopRecordMenu, "Stop recording:");
    Format (szBuffer, sizeof (szBuffer), "Stop %s", g_szDemoRecordName);
    AddMenuItem (hStopRecordMenu, "1", szBuffer);
    AddMenuItem (hStopRecordMenu, "2", "Back");
    DisplayMenu (hStopRecordMenu, client, MENU_TIME_FOREVER);
}

Handle:CreateListMenuFromFile (String:szFile[], MenuHandler:Handler_Menu, String:szMenuTitle[])
{
    new Handle:hFile = INVALID_HANDLE;
    decl String:szBuffer[256] = "";
    new Handle:hMenu = INVALID_HANDLE;
    static iMenuSlot = 0;

    if ((hFile = OpenFile (szFile, "r")) != INVALID_HANDLE)
    {
        LogMessage ("[YGMSM] Parsing \"%s\"", szFile);
        hMenu = CreateMenu (Handler_Menu);
        SetMenuTitle (hMenu, szMenuTitle);
        iMenuSlot = 0;
        while (!IsEndOfFile (hFile) && ReadFileLine (hFile, szBuffer, sizeof (szBuffer)))
        {
            TrimString (szBuffer);

            if ((szBuffer[0] == ';') || (szBuffer[1] == ';') ||
                (szBuffer[0] == '/') || (szBuffer[1] == '/') ||
                !IsCharAlpha (szBuffer[0]))
                continue;

            if (!strcmp (szFile, g_szMapListFileLoc, false) && !IsMapValid (szBuffer))
                continue;

            AddMenuItem (hMenu, szBuffer, szBuffer);

            iMenuSlot++;
            if (iMenuSlot == 6)
            {
                AddMenuItem (hMenu, "menubk", "Back");
                iMenuSlot++;
            }
        }
        while (iMenuSlot <= 6)
        {
            if (iMenuSlot == 6)
                AddMenuItem (hMenu, "menubk", "Back");
		    else
		        AddMenuItem (hMenu, "", "", ITEMDRAW_SPACER);
            iMenuSlot++;
        }
        CloseHandle (hFile);
    }
    else
    {
        LogMessage ("[YGMSM] Unable to find \"%s\"", szFile);
        return INVALID_HANDLE;
    }

    LogMessage ("[YGMSM] Finished parsing \"%s\"", szFile);
    return hMenu;
}

Handle:CreateRconCommandListMenu ()
{
    decl String:szBuffer[128] = "", String:szRconCommandName[64] = "", String:szRconCommand[64] = "";
    static iNumRconCommands = 0, iIndex = 0, iPos = -1, iMenuSlot = 0;
    new Handle:hMapFile = INVALID_HANDLE, Handle:hRconCommandListMenu = INVALID_HANDLE;

    if ((hMapFile = OpenFile ("cfg/ygmsm/rconcommands.ini", "r")) != INVALID_HANDLE)
    {
        LogMessage ("[YGMSM] Parsing rconcommands.ini");
        iNumRconCommands = 0;
        iMenuSlot = 0;
        hRconCommandListMenu = CreateMenu (Handler_RconCommandListMenu);
        SetMenuTitle (hRconCommandListMenu, "Select a custom RCON command:");

        while ((iNumRconCommands <= MAX_CUSTOM_RCON_COMMANDS) && !IsEndOfFile (hMapFile) &&
               ReadFileLine (hMapFile, szBuffer, sizeof (szBuffer)))
        {
            TrimString (szBuffer);

            if ((szBuffer[0] != '\0') && (szBuffer[0] != ';') &&
                (szBuffer[0] != '/') && (szBuffer[1] != '/') &&
				(szBuffer[0] == '"'))
            {
                iIndex = 0;
                if ((iPos = BreakString (szBuffer[iIndex], szRconCommandName, sizeof (szRconCommandName))) != -1)
                {
                    iIndex += iPos;
                    strcopy (szRconCommand, sizeof (szRconCommand), szBuffer[iIndex]);
                    AddMenuItem (hRconCommandListMenu, szRconCommand, szRconCommandName);
                    iNumRconCommands++;
                    iMenuSlot++;

                    if (iMenuSlot == 6)
                    {
                        AddMenuItem (hRconCommandListMenu, "menubk", "Back");
                        iMenuSlot++;
                    }

                }
            }
        }

        while (iMenuSlot <= 6)
        {
            if (iMenuSlot == 6)
                AddMenuItem (hRconCommandListMenu, "menubk", "Back");
		    else
		        AddMenuItem (hRconCommandListMenu, "", "", ITEMDRAW_SPACER);
            iMenuSlot++;
        }

        LogMessage ("[YGMSM] Finished parsing rconcommands.ini - Found %d diffrent RCON commands", iNumRconCommands);
        CloseHandle (hMapFile);
        return hRconCommandListMenu;
    }
    
    LogMessage ("[YGMSM] Error - Unable to find rconcommands.ini - check its in cfg/ygmsm/rconcommands.ini");
    return INVALID_HANDLE;
}

CreateUnbanMenu (client, iBanType)
{
    decl String:szBan[32] = "", String:szBanIndex[10] = "";
    new Handle:hMenu = INVALID_HANDLE;
    static iIndex = 0, iSize = 0,  iMenuSlot = 0;

    if (iBanType == BAN_TYPE_ID)
    {
        hMenu = CreateMenu (Handler_UnbanIDMenu);
        SetMenuTitle (hMenu, g_szUnbanIDMenuTitle);
        iSize = GetArraySize (g_hArrayIDBans);
        iIndex = 0;
        iMenuSlot = 0;
        while (iIndex < iSize)
	    {
	        GetArrayString (g_hArrayIDBans, iIndex, szBan, sizeof (szBan));
	        IntToString (iIndex, szBanIndex, sizeof (szBanIndex));
	        AddMenuItem (hMenu, szBanIndex, szBan);
	        iIndex++;

	        iMenuSlot++;
	        if (iMenuSlot == 6)
	            AddMenuItem (hMenu, "back", "Back");

		}
	}
	else if (iBanType == BAN_TYPE_IP)
	{
	    hMenu = CreateMenu (Handler_UnbanIPMenu);
	    SetMenuTitle (hMenu, g_szUnbanIPMenuTitle);
	    iSize = GetArraySize (g_hArrayIPBans);
	    iIndex = 0;
	    iMenuSlot = 0;
	    while (iIndex < iSize)
	    {
	        GetArrayString (g_hArrayIPBans, iIndex, szBan, sizeof (szBan));
	        IntToString (iIndex, szBanIndex, sizeof (szBanIndex));
	        AddMenuItem (hMenu, szBanIndex, szBan);
	        iIndex++;

	        iMenuSlot++;
	        if (iMenuSlot == 6)
	            AddMenuItem (hMenu, "back", "Back");

        }
    }

    while (iMenuSlot <= 6)
    {
        if (iMenuSlot == 6)
            AddMenuItem (hMenu, "back", "Back");
		else
		    AddMenuItem (hMenu, "", "", ITEMDRAW_SPACER);
        iMenuSlot++;
    }

    DisplayMenu (hMenu, client, MENU_TIME_FOREVER);
}

Handle:CreateLo3Ko3RRMenu ()
{
    new Handle:hLo3Ko3RRMenu = INVALID_HANDLE;

    hLo3Ko3RRMenu = CreateMenu (Handler_Lo3Ko3RRMenu);
    SetMenuTitle (hLo3Ko3RRMenu, "Run KO3/LO3/1xRR:");
    AddMenuItem (hLo3Ko3RRMenu, "1", "Run KO3");
    AddMenuItem (hLo3Ko3RRMenu, "2", "Run LO3");
    AddMenuItem (hLo3Ko3RRMenu, "3", "Run 1xRR");
    AddMenuItem (hLo3Ko3RRMenu, "4", "Back");
    return hLo3Ko3RRMenu;
}

Handle:CreateAdminMenu ()
{
    new Handle:hAdminMenu = INVALID_HANDLE;

    hAdminMenu = CreateMenu (Handler_AdminMenu);
    SetMenuTitle (hAdminMenu, "Select an admin option:");
    AddMenuItem (hAdminMenu, "1", "Player Management");
    AddMenuItem (hAdminMenu, "2", "Server Management");
    return hAdminMenu;
}

Handle:CreatePlayerManagementMenu ()
{
    new Handle:hPlayerManagementMenu = INVALID_HANDLE;

    hPlayerManagementMenu = CreateMenu (Handler_PlayerManagementMenu);
    SetMenuTitle (hPlayerManagementMenu, "Player Management:");
    AddMenuItem (hPlayerManagementMenu, "1", "Kick Player");
    AddMenuItem (hPlayerManagementMenu, "2", "Ban Player");
    AddMenuItem (hPlayerManagementMenu, "3", "Unban Player");
    AddMenuItem (hPlayerManagementMenu, "4", "Mute Player");
    AddMenuItem (hPlayerManagementMenu, "5", "Swap Team");
    AddMenuItem (hPlayerManagementMenu, "6", "Back");
    return hPlayerManagementMenu;
}

Handle:CreateServerManagementMenu ()
{
    new Handle:hServerManagementMenu = INVALID_HANDLE;

    hServerManagementMenu = CreateMenu (Handler_ServerManagementMenu);
    SetMenuTitle (hServerManagementMenu, "Server Management:");
    AddMenuItem (hServerManagementMenu, "1", "Change Map");
    AddMenuItem (hServerManagementMenu, "2", "Run KO3/LO3/One RR");
    AddMenuItem (hServerManagementMenu, "3", "Record TV");
    AddMenuItem (hServerManagementMenu, "4", "Stop TV Recording");
    AddMenuItem (hServerManagementMenu, "5", "Change Server Password");
    AddMenuItem (hServerManagementMenu, "6", "Exec Server Config");
    AddMenuItem (hServerManagementMenu, "7", "Back");
    AddMenuItem (hServerManagementMenu, "8", "Custom RCON Command/s");
    return hServerManagementMenu;
}

Handle:CreateUnbanTypeMenu ()
{
    new Handle:hUnbanTypeMenu = INVALID_HANDLE;

    hUnbanTypeMenu = CreateMenu (Handler_UnbanTypeMenu);
    SetMenuTitle (hUnbanTypeMenu, "Select the ban type to remove:");
    AddMenuItem (hUnbanTypeMenu, "1", "Steam ID");
    AddMenuItem (hUnbanTypeMenu, "2", "IP Address");
    AddMenuItem (hUnbanTypeMenu, "3", "Back");
    return hUnbanTypeMenu;
}

CreateTeamSwapMenu (client, const String:szClientToSwap[])
{
    new Handle:hSwapTeamChoiceMenu = INVALID_HANDLE;
    new String:szTeamClient[10] = "";
    static iIndex = 0;

    iIndex = 0;
    szTeamClient[iIndex] = szClientToSwap[0];
    if (szClientToSwap[1] != '\0')
    {
        iIndex++;
        szTeamClient[iIndex] = szClientToSwap[1];
    }

    szTeamClient[iIndex+1] = '|';

    hSwapTeamChoiceMenu = CreateMenu (Handler_SwapTeamChoiceMenu);
    SetMenuTitle (hSwapTeamChoiceMenu, "Select the team to swap to:");
    szTeamClient[iIndex+2] = '1';
    szTeamClient[iIndex+3] = '\0';
    AddMenuItem (hSwapTeamChoiceMenu, szTeamClient, "Spectator");
    szTeamClient[iIndex+2] = '2';
    AddMenuItem (hSwapTeamChoiceMenu, szTeamClient, "Terrorist");
    szTeamClient[iIndex+2] = '3';
    AddMenuItem (hSwapTeamChoiceMenu, szTeamClient, "Counter-Terrorist");
    AddMenuItem (hSwapTeamChoiceMenu, "back", "Back");
    DisplayMenu (hSwapTeamChoiceMenu, client, MENU_TIME_FOREVER);
}
