
UTIL_FreeHandle (Handle:hHandle)
{
    if (hHandle != INVALID_HANDLE)
    {
        CloseHandle (hHandle);
        hHandle = INVALID_HANDLE;
    }
}

UTIL_SetupOffsets ()
{
    g_iMoney = FindSendPropOffs ("CCSPlayer", "m_iAccount");
    if (g_iMoney == -1)
        SetFailState ("[YGMSM] Error - Unable to get offset for CCSPlayer::m_iAccount");

    g_iMyWeapons = FindSendPropOffs ("CBaseCombatCharacter", "m_hMyWeapons");
    if (g_iMyWeapons == -1)
        SetFailState ("[YGMSM] Error - Unable to get offset for CBaseCombatCharacter::m_hMyWeapons");

    g_hGameConf = LoadGameConfigFile ("ygmsm.games");
    if (g_hGameConf == INVALID_HANDLE)
        SetFailState ("[YGMSM] Error - Unable to find \"ygmsm.games.txt\"");

    StartPrepSDKCall (SDKCall_Player);
    PrepSDKCall_SetFromConf (g_hGameConf, SDKConf_Virtual, "Weapon_Equip");
    PrepSDKCall_AddParameter (SDKType_CBaseEntity, SDKPass_Pointer);
    g_hEquipWeapon = EndPrepSDKCall ();
}


/* thanks to devicenull for the original code, changed it a little bit ;) */
UTIL_RemoveAllButKnife (client)
{
    static iWeaponSlot = 0, iEntIndex = 0;
    decl String:szClassName[32] = "";
    
    for (iWeaponSlot = 0; iWeaponSlot <= (32 * 4); iWeaponSlot += 4)
    {
        iEntIndex = GetEntDataEnt (client, (g_iMyWeapons + iWeaponSlot));
        if (iEntIndex != 0)
        {
            GetEdictClassname (iEntIndex, szClassName, sizeof (szClassName));
            if (!strcmp (szClassName, "worldspawn", false))
                continue;
            if (!strcmp (szClassName, "weapon_knife", false))
                continue;

            RemovePlayerItem (client, iEntIndex);
            RemoveEdict (iEntIndex);
        }
    }
}

/* thanks to dalto for this function */
UTIL_EquipKnife (client)
{
    static weaponEntity = -1;

    weaponEntity = GetPlayerWeaponSlot (client, 2);
    if (weaponEntity != -1)
        SDKCall (g_hEquipWeapon, client, weaponEntity);
}

UTIL_SetClientsKnivesOnly ()
{
    if (GetConVarBool (g_cVarKnifeRoundStrip))
    {
        new iClient;
        new iMaxClients = GetMaxClients ();

        iClient = 1;
        while (iClient <= iMaxClients)
        {
            if (IsClientConnected (iClient) && IsClientInGame (iClient) && !IsFakeClient (iClient))
            {
                SetEntData (iClient, g_iMoney, 0);
                UTIL_RemoveAllButKnife (iClient);
                UTIL_EquipKnife (iClient);
            }

            iClient++;
        }
    }
}

UTIL_RunOneRR ()
{
    PrintToChatAll ("%c%cRunning 1xRR", DEFAULT_COLOUR, DARK_GREEN);
    ServerCommand ("mp_restartgame 1");
}

UTIL_RunKO3 (client)
{
    if (g_iClientRunningLo3Ko3 == -1)
        g_iClientRunningLo3Ko3 = client;
    CreateTimer (2.0, RunKnivesOnThree, client, TIMER_REPEAT);
}

UTIL_RunLO3 (client)
{
    if (g_iClientRunningLo3Ko3 == -1)
        g_iClientRunningLo3Ko3 = client;
    CreateTimer (2.0, RunLiveOnThree, client, TIMER_REPEAT);
}

UTIL_PrintToConsoleAll (const String:szFormat[], any:...)
{
    new iClientCount = GetClientCount (true) + 1, iIndex = 0;

    iIndex = 1;
    while (iIndex <= iClientCount)
    {
        if (IsClientConnected (iIndex) && IsClientInGame (iIndex) && !IsFakeClient (iIndex))
            PrintToConsole (iIndex, szFormat);
        iIndex++;
    }
}

UTIL_FindClient (client, String:szMatch[])
{
    new iClients[2], iClientsFound = 0;

    iClientsFound = SearchForClients (szMatch, iClients, 2);

    if (iClientsFound == 0)
    {
        PrintToChat (client, "No client found using search string %s", szMatch);
        return -1;
    }
    else if (iClientsFound > 1)
    {
        PrintToChat (client, "More than one client found using search string %s", szMatch);
        return -1;
    }

    return iClients[0];
}

ParseServerBanFiles (iBanType, const String:szBannedFile[])
{
    new Handle:hFile = INVALID_HANDLE;
    decl String:szBuffer[PLATFORM_MAX_PATH] = "", String:szBreakBuffer[64] = "";
    static iIndex, iPos = -1;
    
    if ((hFile = OpenFile (szBannedFile, "r")) != INVALID_HANDLE)
    {
        LogMessage ("[YGMSM] Parsing \"%s\"", szBannedFile);
        
        while (!IsEndOfFile (hFile) && ReadFileLine (hFile, szBuffer, sizeof (szBuffer)))
        {
            TrimString (szBuffer);
            
            if ((szBuffer[0] == ';') || (szBuffer[1] == ';') ||
				(szBuffer[0] == '/') || (szBuffer[1] == '/') ||
				!IsCharAlpha (szBuffer[0]))
                continue;
            iIndex = 0;

            if ((iPos = BreakString (szBuffer[iIndex], szBreakBuffer, sizeof (szBreakBuffer))) == -1)
                continue;
            iIndex += iPos;

            if ((iPos = BreakString (szBuffer[iIndex], szBreakBuffer, sizeof (szBreakBuffer))) == -1)
                continue;
            iIndex += iPos;

            strcopy (szBreakBuffer, sizeof (szBreakBuffer), szBuffer[iIndex]);

            if (iBanType == BAN_TYPE_ID)
                PushArrayString (g_hArrayIDBans, szBreakBuffer);
            else if (iBanType == BAN_TYPE_IP)
                PushArrayString (g_hArrayIPBans, szBreakBuffer);
        }

        CloseHandle (hFile);
    }
    else
    {
        LogMessage ("[YGMSM] Unable to find \"%s\"", szBannedFile);
        return;
    }

    if (iBanType == BAN_TYPE_ID)
        LogMessage ("[YGMSM] Finished parsing \"%s\" - Found %d diffrent ID bans", szBannedFile, GetArraySize (g_hArrayIDBans));
    else if (iBanType == BAN_TYPE_IP)
        LogMessage ("[YGMSM] Finished parsing \"%s\" - Found %d diffrent IP bans", szBannedFile, GetArraySize (g_hArrayIPBans));

}

